<template>
  <div
    v-if="isSelectProvider"
    class="games-providers__toggle"
    data-provider-menu=""
    @click="drawer = true"
  >
    {{ $t("select_provider")
    }}<font-awesome-icon class="ml-3" icon="arrow-right" />
  </div>
  <div v-else-if="isGamePage" class="see-all-link" @click="drawer = true">
    {{ $t("see_all") }}
    <font-awesome-icon class="ml-4" icon="arrow-right" />
  </div>
  <el-menu-item
    v-else
    :class="`${isCollapse ? 'is-collapse-menu' : ''} special-menu-tab-item`"
    @click="drawer = true"
  >
    <el-icon
      :class="`${
        isGameProvider
          ? 'menu-tab-icon-games-provider'
          : 'menu-tab-icon-games-type'
      }`"
    ></el-icon>
    <template v-if="!isCollapse" #title>
      <div class="ml-[29px] flex justify-between w-full items-center">
        <span v-if="isGameProvider">{{ $t("game_provider") }}</span>
        <span v-else>{{ $t("game_category") }}</span>
        <font-awesome-icon
          icon="play"
          class="text-[5px] absolute right-[10px]"
        />
      </div>
    </template>
  </el-menu-item>
  <div>
    <el-drawer
      v-model="drawer"
      :title="$t(title)"
      :with-header="true"
      :show-close="true"
    >
      <div class="card-game-pc-wrapper relative">
        <el-card v-for="(game, index) in games" :key="index">
          <nuxt-link
            :to="
              isGameProvider
                ? `/games/${game.ProviderName}__n__gp`
                : `/games/${game}__n__gt`
            "
            :class="{ 'grayscale-[1] pointer-events-none': game.IsMaintain }"
            @click="drawer = false"
          >
            <div
              v-if="game.IsMaintain"
              class="absolute w-12 h-12 top-[20px] left-[35%] z-[2]"
            >
              <img
                :src="
                  getAssetImage(
                    'assets/theme/common/icon/icon_maintainance.png'
                  )
                "
                alt=""
              />
            </div>
            <div
              class="h-[80px] p-[5px] w-full flex justify-center items-center card-image-wrapper"
            >
              <img
                v-if="isGameProvider"
                :src="
                  getAssetImage(
                    `assets/theme/black_modern_1/images/gameProviders/${game.ProviderName.replace(
                      ' ',
                      ''
                    ).toLowerCase()}.png`
                  )
                "
                class="h-full provider-logo-image"
              />
              <img
                v-else
                :src="
                  getAssetImage(
                    `assets/theme/black_modern_1/images/gameIcons/${game
                      .replace(' ', '')
                      .toLowerCase()}.png`
                  )
                "
                class="h-full"
              />
            </div>
            <div class="flex justify-between items-center h-[35px]">
              <span v-if="isGameProvider">{{ game.GameProviderDisplayName }}</span>
              <span v-else>{{ $t(String(game)) }}</span>
              <font-awesome-icon icon="arrow-right-long" />
            </div>
          </nuxt-link>
        </el-card>
      </div>
    </el-drawer>
  </div>
</template>
<script lang="ts">
import { defineComponent, ref, watch } from "vue";
import { useGameEntryComponent } from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  name: "GameProvider",
  props: {
    isCollapse: {
      type: Boolean,
      required: false,
    },
    isGameProvider: {
      type: Boolean,
      default: false,
    },
    isSelectProvider: {
      type: Boolean,
      default: false,
    },
    isGamePage: {
      type: Boolean,
      default: false,
    },
    shouldFixZIndex: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const drawer = ref(false);
    const { providers, gameTypes } = useGameEntryComponent();
    const games = props.isGameProvider ? providers : gameTypes;
    const title = props.isGameProvider ? "game_providers" : "game_category";
    const { getAssetImage } = commonHelper;
    const onProviderOpen = () => {
      const contentContainer = document.getElementById("content-container");
      if (contentContainer) {
        contentContainer.style.zIndex = "30";
      }
    };
    const onProviderClose = () => {
      const contentContainer = document.getElementById("content-container");
      if (contentContainer) {
        contentContainer.style.zIndex = "0";
      }
    };
    watch(
      () => drawer.value,
      () => {
        if (!props.shouldFixZIndex) return;
        if (drawer.value) {
          onProviderOpen();
          return;
        }
        onProviderClose();
      }
    );
    return {
      drawer,
      games,
      title,
      getAssetImage,
    };
  },
});
</script>
<style scoped>
:deep(.el-drawer) {
  width: 55% !important;
}
:deep(.el-drawer__body)::-webkit-scrollbar {
  width: 8px;
}

:deep(.el-drawer__body)::-webkit-scrollbar-thumb {
  background: var(--text2);
  border-radius: 10px;
}
:deep(.el-drawer__body)::-webkit-scrollbar-track {
  box-shadow: inset 0 0 5px transparent;
  border-radius: 10px;
}
@-moz-document url-prefix() {
  :deep(.el-drawer) {
    scrollbar-color: var(--text2) transparent;
  }
}
/* .card-image-wrapper .provider-logo-image {
  filter: grayscale(1);
} */
.el-card:hover .provider-logo-image {
  filter: grayscale(0);
}
.el-menu-item {
  color: var(--text2);
}
.menu-tab-icon-games-type,
.menu-tab-icon-games-provider {
  height: 24px;
}
:deep(.el-drawer__header span) {
  font-size: 2.15rem;
  font-weight: 700;
}
</style>
